<?php
/*
Plugin Name: GPhotos
Plugin URI: http://wordpress.org/extend/plugins/gphotos/
Description: GPhoto is a simple system image galleries easy to use.
Version: 1.7
Author: Grégoire Félix
Author URI: http://profiles.wordpress.org/c-pluswebcom/
License: GNU Free Software
*/



/*  Copyright 2012 Grégoire Félix (email : gregoire.felix@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/



add_action('init', 'GPhotos_init');
add_action('admin_menu', 'afficher_lien_menu');
add_action('admin_head', 'plugin_header');
add_action('add_meta_boxes', 'GPhotos_metaboxes');
add_action('add_meta_boxes', 'GPhotos_metaboxes2');
add_action('add_meta_boxes', 'GPhotos_metaboxes3');
add_action('save_post', 'GPhotos_savepost',10,2);
add_action('save_post', 'GPhotos_savepost2',10,2);
add_action('save_post', 'GPhotos_savepost3',10,2);
add_action('manage_edit-slide_columns', 'GPhotos_columnfilter');
add_action('manage_posts_custom_column', 'GPhotos_column');
add_action( 'wp_enqueue_scripts', 'prefix_add_my_stylesheet' );
add_shortcode("GPhotos", "GPhotos_show");
add_action('wp_footer','GPhotos_script', 30);
add_action('wp_head', 'add_jquery');



/**
* Permet d'ajouter l'icône gphotos à l'admin
**/

function plugin_header() {
        global $post_type;
    ?>
    <style>
    <?php if (($_GET['post_type'] == 'slide') || ($post_type == 'slide')) : ?>
    #icon-edit { background:transparent url('<?php echo plugins_url( 'images/media-button-image.gif', __FILE__ );?>') no-repeat; }    
    <?php endif; ?>  
        </style>
        <?php
}



/**
* Permet d'ajouter le lien guide du plugin
**/

// lier le lien du menu à la page d'options
function afficher_lien_menu() {
  if (function_exists('add_options_page')) {
	  $plugin_page_options = add_options_page('GPhotos Settings', 'GPhotos Settings', 'administrator', 'id_GPhotos', 'fonction_de_la_page_options');
  }
}
 
// la page des options
function fonction_de_la_page_options() {
 
  if (!current_user_can('administrator'))  {
    wp_die( __('You do not have sufficient permissions to access this page.') );
  }
 ?>
  <div class="wrap">
<div id="icon-options-general" class="icon32"><br /></div><h2>Settings</h2>
 <form method="post" action="options.php">
 
<!-- Ajoute 2 champs cachés pour savoir comment rediriger l'utilisateur -->
<?php wp_nonce_field('update-options'); ?>
 
<table class="form-table">

<tr valign="top">
 <h3>Internal parameters</h3>
<!-- Option #1 -->
<th scope="row">Pictures limitation :</th>
<td>
<input type="text" name="option1" id="option1" value="<?php echo get_option('option1'); ?>">
</td>
</tr>

<tr valign="top">
<th scope="row">Indicate the number of the album you want to display :</th>
<td>
<select name="num_album">
    <option value="1"<?php selected( get_option('num_album'), '1' ); ?>>N°1</option>
    <option value="2"<?php selected( get_option('num_album'), '2' ); ?>>N°2</option>
    <option value="3"<?php selected( get_option('num_album'), '3' ); ?>>N°3</option>
    <option value="4"<?php selected( get_option('num_album'), '4' ); ?>>N°4</option>
</select>
</td>
</tr>

<tr valign="top">
<th scope="row">Choose the order of the pictures :</th>
<td>
<select name="order_album">
    <option value="DESC"<?php selected( get_option('order_album'), 'DESC' ); ?>>DESC</option>
    <option value="ASC"<?php selected( get_option('order_album'), 'ASC' ); ?>>ASC</option>
</select>
</td>
</tr>

<tr valign="top">
		<th scope="row"><label for="effect">Not Display link</label></th>
		<td>
<input type="checkbox" name="check1" value="none" 
    <?php if (get_option('check1')==true) echo 'checked="checked" '; ?>></td>
	</tr>
	
		<tr valign="top">
		<th scope="row"><label for="effect">Duration Effect on the pictures</label></th>
		<td><input type="text" id="effect" name="effect" class="small-text" value="<?php echo get_option( 'effect' ); ?>" />ms</td>
	</tr>
	
<tr valign="top">
<th scope="row">Indicate animation of the picture you want to display :</th>
<td>
<select name="effect_pic">
			<option value="swing"<?php selected( get_option('effect_pic'), 'swing' ); ?>>swing</option>
    <option value="linear"<?php selected( get_option('effect_pic'), 'linear' ); ?>>linear</option>
    <option value="easeOutBounce"<?php selected( get_option('effect_pic'), 'easeOutBounce' ); ?>>easeOutBounce</option>
    <option value="easeInElastic"<?php selected( get_option('effect_pic'), 'easeInElastic' ); ?>>easeInElastic</option>
    <option value="easeInOutBounce"<?php selected( get_option('effect_pic'), 'easeInOutBounce' ); ?>>easeInOutBounce</option>
    <option value="easeInOutQuad"<?php selected( get_option('effect_pic'), 'easeInOutQuad' ); ?>>easeInOutQuad</option>
    <option value="easeInCubic"<?php selected( get_option('effect_pic'), 'easeInCubic' ); ?>>easeInCubic</option>
    <option value="easeOutCubic"<?php selected( get_option('effect_pic'), 'easeOutCubic' ); ?>>easeOutCubic</option>
    <option value="easeOutQuint"<?php selected( get_option('effect_pic'), 'easeOutQuint' ); ?>>easeOutQuint</option>
    <option value="easeInCirc"<?php selected( get_option('effect_pic'), 'easeInCirc' ); ?>>easeInCirc</option>
    <option value="easeOutElastic"<?php selected( get_option('effect_pic'), 'easeOutElastic' ); ?>>easeOutElastic</option>
    <option value="easeInOutElastic"<?php selected( get_option('effect_pic'), 'easeInOutElastic' ); ?>>easeInOutElastic</option>
    <option value="easeInBounce"<?php selected( get_option('effect_pic'), 'easeInBounce' ); ?>>easeInBounce</option>
</select>
</td>
</tr>
	
</table>
<h3>Design Settings (container)</h3>
<table class="form-table">
<!-- Option #2 -->
<tr valign="top">
		<th scope="row"><label for="background_color">Background color</label></th>
		<td><input type="color" id="option7" name="background_color" class="small-text" value="<?php echo get_option( 'background_color' ); ?>" /> Indicate "none" if you don't want to display this one.s</td>
	</tr>

	<tr valign="top">
		<th scope="row"><label for="text_color">Border color</label></th>
		<td><input type="color" id="option3" name="text_color" class="small-text" value="<?php echo get_option( 'text_color' ); ?>" /> Indicate "none" if you don't want to display this one.</td>
	</tr>
	
	<tr valign="top">
		<th scope="row"><label for="border_pixel">Border pixel</label></th>
		<td><input type="text" id="option6" name="border_pixel" class="small-text" value="<?php echo get_option( 'border_pixel' ); ?>" />px</td>
	</tr>
	
		<tr valign="top">
		<th scope="row"><label for="link_color">Link color</label></th>
		<td><input type="color" id="option4" name="link_color" class="small-text" value="<?php echo get_option( 'link_color' ); ?>" /> Indicate "none" if you don't want to display this one.</td>
	</tr>
	
	<tr valign="top">
		<th scope="row"><label for="padding">Padding</label></th>
		<td><input type="text" id="option10" name="padding" class="small-text" value="<?php echo get_option( 'padding' ); ?>" />px</td>
	</tr>
	
		<tr valign="top">
		<th scope="row"><label for="box_shadow_pixel">Pixel Box Shadow</label></th>
		<td><input type="text" id="option9" name="box_shadow_pixel" class="small-text" value="<?php echo get_option( 'box_shadow_pixel' ); ?>" />px</td>
	</tr>
	
	<tr valign="top">
		<th scope="row"><label for="box_shadow">Color Box Shadow</label></th>
		<td><input type="color" id="option8" name="box_shadow" class="small-text" value="<?php echo get_option( 'box_shadow' ); ?>" /> Indicate "none" if you don't want to display this one.</td>
	</tr>
	
	<tr valign="top">
		<th scope="row"><label for="margin_bottom">Margin Bottom</label></th>
		<td><input type="text" id="margin_bottom" name="margin_bottom" class="small-text" value="<?php echo get_option( 'margin_bottom' ); ?>" />px</td>
	</tr>
	
</table>

<h3>Design Settings (pictures)</h3>
<table class="form-table">
<!-- Option #2 -->
<tr valign="top">
		<th scope="row"><label for="background_color">Border pixel</label></th>
		<td><input type="text" id="option2" name="border_pixel_pic" class="small-text" value="<?php echo get_option( 'border_pixel_pic' ); ?>" />px</td>
	</tr>
	
	<tr valign="top">
		<th scope="row"><label for="background_color">Border-radius pixel</label></th>
		<td><input type="text" id="option11" name="border_rad_pixel_pic" class="small-text" value="<?php echo get_option( 'border_rad_pixel_pic' ); ?>" />px</td>
	</tr>
	
</table>
<!-- Mise à jour des valeurs -->
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="order_album, border_rad_pixel_pic, effect_pic, check1, effect, option1, num_album, text_color, background_color, link_color, border_pixel, border_pixel_pic, margin_bottom, box_shadow, box_shadow_pixel, padding" />
 
<!-- Bouton de sauvegarde -->
<p>
<input type="submit" class="button-primary" value="<?php _e('Save Changes'); ?>" />
</p>
</form>

 
 <?php

}

/**
* Permet d'initialiser le stylesheet du plugin
**/

    function prefix_add_my_stylesheet() {
        // Respects SSL, Style.css is relative to the current file
        wp_register_style( 'prefix-style', plugins_url('css/zoombox.css', __FILE__) );
        wp_enqueue_style( 'prefix-style' );
    }



/**
* Permet d'initialiser les fonctionnalités liées au Plugin
**/

function GPhotos_init(){

	
$labels = array(
'name' => 'GPhotos',
'singular_name' => 'GPhotos',
'add_new' => 'Add a picture',
'add_new_item' => 'Add a new picture',
'edit_item' => 'Edit a picture',
'new_item' => 'View the picture',
'search_items' => 'Search a picture',
'not_found' => 'Picture not found',
'not_found_in_trash' => 'Picture not found in the trash',
'parent_item_colon' => '',
'menu_name' => 'GPhotos'
);

register_post_type('slide', array(
   'labels' => $labels,
    'public' => true,
    'publicly_queryable' => true,
    'show_ui' => true, 
    'menu_icon' => plugins_url( 'images/media-button-image.gif', __FILE__ ), // 16px16
    'show_in_menu' => true, 
    'query_var' => true,
    'rewrite' => array( 'slug' => 'GPhotos' ),
    'capability_type' => 'post',
    'has_archive' => true, 
    'hierarchical' => false,
    'menu_position' => 9,
    'supports' => array( 'title', 'author', 'thumbnail')
));

add_image_size('photos', 143, 95, true);
}


/**
* Permet d'ajouter le champ numéro de l'album
**/



	function GPhotos_metaboxes3(){
		
add_meta_box('GPhotos3','Album','GPhotos_metabox3','slide','side', 'high');		
		
		}
// cette fonction me sert à inscrire checked, si jamais la valeur est coché
function check($cible,$test){
  if(in_array($test,$cible)){return 'checked';}
}
function GPhotos_metabox3($post){
  $cond = get_post_meta($post->ID,'_album',false);
  echo '<p>Checked the number of your album where you will find this photo :</p>';
  echo '<p><label><input type="checkbox" name="cond[]" value="1" /> N° 1</label></p>';
  echo '<p><label><input type="checkbox" name="cond[]" value="2" /> N° 2</label></p>';
  echo '<p><label><input type="checkbox" name="cond[]" value="3" /> N° 3</label></p>';
  echo '<p><label><input type="checkbox" name="cond[]" value="4" /> N° 4</label></p>';
}

function GPhotos_savepost3($post_id){
  if(isset($_POST['cond'])){
    // je supprime toutes les entrées pour cette meta
    delete_post_meta($post_id, '_album');
    // et pour chaque conditionnement coché, j'ajoute une metadonnée
    foreach($_POST['cond'] as $c){
      update_post_meta($post_id, '_album', intval($c) );
    }
  }
}


/**
* Permet d'ajouter la meta box Lien
**/

function GPhotos_metaboxes(){
	
	add_meta_box('GPhotos','Link','GPhotos_metabox','slide','normal','high');
	
	}


function GPhotos_metabox($object){
	wp_nonce_field('GPhotos','GPhotos_nonce');
?>
<div class="meta-box-item-title">
<h4>Link of the picture</h4>
<div class="url_meta">
<input type="text" name="GPhotos_link" style="width:100%"
 value="<?php echo esc_attr(get_post_meta($object->ID, '_link', true)); ?>">
</div>
</div>
<?php		
	}

	function GPhotos_savepost($post_id, $post){
		
		if(!isset($_POST['GPhotos_link']) || !wp_verify_nonce($_POST['GPhotos_nonce'], 'GPhotos')){
return $post_id;			
			}
			
$type = get_post_type_object($post->post_type);			
			if(!current_user_can($type->cap->edit_post)){
return $post_id;				
				}
		update_post_meta($post_id,'_link',$_POST['GPhotos_link']);
		}

/**
* Permet d'ajouter la meta box Commentaire
**/

	function GPhotos_metaboxes2(){
		
add_meta_box('GPhotos2','Comments','GPhotos_metabox2','slide','normal', 'high');		
		
		}

	function GPhotos_metabox2($object){
	wp_nonce_field('GPhotos2','GPhotos2_nonce');
?>
<div class="meta-box-item-title">
<h4>Comments of the picture</h4>
<div class="meta-box-item-content">
<input type="text" name="GPhotos_comm" style="width:100%"
 value="<?php echo esc_attr(get_post_meta($object->ID, '_comm', true)); ?>">
</div>
</div>
<?php		
	}
	
		function GPhotos_savepost2($post_id, $post){
		
		if(!isset($_POST['GPhotos_comm']) || !wp_verify_nonce($_POST['GPhotos2_nonce'], 'GPhotos2')){
return $post_id;			
			}
			
$type = get_post_type_object($post->post_type);			
			if(!current_user_can($type->cap->edit_post)){
return $post_id;				
				}
		update_post_meta($post_id,'_comm',$_POST['GPhotos_comm']);
		}
	
	
	
/**
* Permet d'afficher les colonnes dans l'admin
**/

function GPhotos_columnfilter($columns){
	$thumb = array('thumbnail' => 'Picture');
	$columns = array_slice($columns, 0, 1) + $thumb + array_slice($columns,1,null);
 $columns['album'] = __('album');
 
	return $columns;
	}

function GPhotos_column($column){
	global $post;
if($column == 'thumbnail')	{
echo edit_post_link(get_the_post_thumbnail($post->ID), null,null,$post->ID);

	}
	elseif($column == 'album')	{
echo edit_post_link(get_post_meta($post->ID, '_album', true), null,null,$post->ID);

	}
	
	}




/**
* Permet d'appeler les scripts
**/


function add_jquery() {
	 wp_deregister_script('jquery');
		wp_enqueue_script('zoombox',plugins_url().'/gphotos/js/zoombox.js', array('jquery'),'4.6.4',true);
		wp_enqueue_script('jquery','https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js',null,'1.7.2',true);
		wp_enqueue_script('jqueryUI','https://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js',null,'1.9.2',true);
}



/**
* Permet d'afficher le Plugin
**/


function GPhotos_show(){

	
		/**
		** Variable pour les options du plugin
		**/
		
		$limit = get_option('option1');
		$background_color = get_option('background_color');
		$text_color = get_option( 'text_color' );
		$link_color = get_option( 'link_color' );
	 $num_album = get_option( 'num_album' );
		$border_pixel = get_option('border_pixel');
		$border_pixel_pic = get_option('border_pixel_pic');
		$margin_bottom = get_option('margin_bottom');
		$box_shadow = get_option('box_shadow');
		$box_shadow_pixel = get_option('box_shadow_pixel');
		$padding = get_option('padding');
		$effect = get_option('effect');
		$check1 = get_option('check1');
		$effect_pic = get_option('effect_pic');
		$border_rad_pixel_pic = get_option('border_rad_pixel_pic');
		$order_album = get_option('order_album');
		
		
		/**
		** Affichage
		**/
		
		
		$photos = new WP_query("post_type=slide&posts_per_page=$limit&order=$order_album");
		echo '<div id="GPhotos" style="
		background-color: '.$background_color.';
		color: '.$text_color.';
		border-width: '.$border_pixel.'px;
		-moz-border-bottom-colors: none;
    -moz-border-left-colors: none;
    -moz-border-right-colors: none;
    -moz-border-top-colors: none;
    border-style: solid;
    margin-bottom: '.$margin_bottom.'px;
    box-shadow: '.$box_shadow_pixel.'px '.$box_shadow_pixel.'px '.$box_shadow_pixel.'px '.$box_shadow.';
    display: inline-block;
    padding: '.$padding.'px;
    list-style:none outside none;
		">';
		while($photos->have_posts()){
				$photos->the_post();
				$large_image_url = wp_get_attachment_image_src( get_post_thumbnail_id(), 'large');
				global $post;
				if(get_post_meta($post->ID, '_album', true) == $num_album){
			echo '<div class="image"><a class="zoombox '.esc_attr(get_post_meta($post->ID, '_album', true)).'" alt="'.esc_attr(get_post_meta($post->ID, '_comm', true)).'" 
			title="'.esc_attr(get_the_title($post->ID)).'" 
			href="'.$large_image_url[0].'">';
				the_post_thumbnail('photos', array('style' => 
				'width:143px!important;
				height:95px!important;
				border:'.$border_pixel_pic.'px solid white!important;
				-webkit-border-radius: '.$border_rad_pixel_pic.'px!important;
		  	-moz-border-radius: '.$border_rad_pixel_pic.'px!important;
			 border-radius: '.$border_rad_pixel_pic.'px!important;
				'));			
		echo '</a>';
		echo '<div class="lien">
		<a style="color:'.$link_color.'; display:'.$check1.';" href="'.esc_attr(get_post_meta($post->ID, '_link', true)).'">';
		echo get_post_meta($post->ID, '_link', true);
		echo '</a></div></div>';
			}
			}
	echo '</div>';

	}



	
	/**
* Permet d'initialiser le script Zoombox.js
**/

function GPhotos_script(){
	?>
	 <script type="text/javascript"> 
    jQuery(function(){
        jQuery('a.zoombox').zoombox();
    });
    
</script>  
<script type="text/javascript"> 
jQuery(document).ready(function(){

//Larger thumbnail preview 

jQuery("a.zoombox").hover(function() {
	jQuery(this).css({'z-index' : '10'});
	jQuery(this).find('img').addClass("hover").stop()
		.animate({
			marginTop: '-25px', 
			marginLeft: '-10px',
			top: '0px', 
			left: '0px', 
			width: '153px', 
			height: '105px',
			padding: '0px' 
		},<?php echo get_option( 'effect' ); ?>, '<?php echo get_option( 'effect_pic' ); ?>');
		
	
	} , function() {
	jQuery(this).css({'z-index' : '0'});
	jQuery(this).find('img').removeClass("hover").stop()
		.animate({
			marginTop: '0px', 
			marginLeft: '0px',
			top: '0px', 
			left: '0px', 
			width: '143px', 
			height: '95px', 
			padding: '0px'
		}, 50);
});

 
});
</script> 
	<?php
	}
	

?>
